PROJ = getsend
PROJFILE = getsend.mak
DEBUG = 0

CC  = cl
CFLAGS_G  = /AL /W4 /G2 /Zp1 /J /BATCH
CFLAGS_D  = /qc /Giout\$(PROJ).mdt /Zr /Zi /Od
CFLAGS_R  = /Od /Gs
MAPFILE_D  = NUL
MAPFILE_R  = NUL
LFLAGS_G  = /NOI /BATCH
LFLAGS_D  = /CO /INC /FAR /PACKC /PACKD /PMTYPE:VIO
LFLAGS_R  = /EXE /FAR /PACKC /PACKD /PMTYPE:VIO
LINKER  = link
ILINK  = ilink
LRF  = echo > NUL

DEF_FILE  = GETSEND.DEF
OBJS  = out\GETSEND.obj out\ffprintf.obj out\DELIMS.obj out\prseaddr.obj\
        out\STRIPS.obj out\LOADADDR.obj out\srchpath.obj out\fgetsx.obj\
        out\capname.obj out\nodelist.obj

all: out\$(PROJ).exe

.SUFFIXES:
.SUFFIXES: .obj .c

out\GETSEND.obj : GETSEND.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\GETSEND.obj GETSEND.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\GETSEND.obj GETSEND.C
!ENDIF

out\ffprintf.obj : ffprintf.c
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\ffprintf.obj ffprintf.c
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\ffprintf.obj ffprintf.c
!ENDIF

out\DELIMS.obj : DELIMS.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\DELIMS.obj DELIMS.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\DELIMS.obj DELIMS.C
!ENDIF

out\prseaddr.obj : prseaddr.c
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\prseaddr.obj prseaddr.c
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\prseaddr.obj prseaddr.c
!ENDIF

out\STRIPS.obj : STRIPS.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\STRIPS.obj STRIPS.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\STRIPS.obj STRIPS.C
!ENDIF

out\LOADADDR.obj : LOADADDR.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\LOADADDR.obj LOADADDR.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\LOADADDR.obj LOADADDR.C
!ENDIF

out\srchpath.obj : srchpath.c
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\srchpath.obj srchpath.c
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\srchpath.obj srchpath.c
!ENDIF

out\fgetsx.obj : fgetsx.c
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\fgetsx.obj fgetsx.c
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\fgetsx.obj fgetsx.c
!ENDIF

out\capname.obj : capname.c
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\capname.obj capname.c
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\capname.obj capname.c
!ENDIF

out\nodelist.obj : nodelist.c
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\nodelist.obj nodelist.c
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\nodelist.obj nodelist.c
!ENDIF


out\$(PROJ).exe : $(DEF_FILE) $(OBJS)
!IF $(DEBUG)
  $(LRF) @<<out\$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_D)
$(LLIBS_G: = +^
) +
$(LLIBS_D: = +^
) +
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_D);
<<
!ELSE
        $(LRF) @<<out\$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_R)
$(LLIBS_G: = +^
) +
$(LLIBS_R: = +^
) +
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_R);
<<
!ENDIF
!IF $(DEBUG)
  $(ILINK) -a -e "$(LINKER) @out\$(PROJ).lrf" $@
!ELSE
  $(LINKER) @out\$(PROJ).lrf
!ENDIF
  del out\gs.exe
  ren out\$(PROJ).exe gs.exe

.c.obj :
!IF $(DEBUG)
  $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Fo$@ $<
!ELSE
  $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Fo$@ $<
!ENDIF


run: out\$(PROJ).exe
     out\$(PROJ).exe $(RUNFLAGS)

debug: out\$(PROJ).exe
        CVP $(CVFLAGS) out\$(PROJ).exe $(RUNFLAGS)
