/* keys.h file
 *
 * these define keys as returned by inkey()
 *
 */


#define YOOHOO       0xf1
#define NUL          0x00
#define TSYNCH       0xae
#define ACK          0x06
#define NAK          0x15
#define SOH          0x01
#define SUB          0x1a
#define SYN          0x16
#define EOT          0x04
#define ENQ          0x05
#define CAN          0x18
#define ETX          0x03
#define ETB          0x17

#define TAB         9
#define HT          9
#define RUBOUT      8
#define KILL        127
#define BELL        7
#define ESC         27
#define SHIFT_HT    15+1024
#define SHIFT_TAB   15+1024

#define ALT_A       30+1024
#define ALT_B       48+1024
#define ALT_C       46+1024
#define ALT_D       32+1024
#define ALT_E       18+1024
#define ALT_F       33+1024
#define ALT_G       34+1024
#define ALT_H       35+1024
#define ALT_I       23+1024
#define ALT_J       36+1024
#define ALT_K       37+1024
#define ALT_L       38+1024
#define ALT_M       50+1024
#define ALT_N       49+1024
#define ALT_O       24+1024
#define ALT_P       25+1024
#define ALT_Q       16+1024
#define ALT_R       19+1024
#define ALT_S       31+1024
#define ALT_T       20+1024
#define ALT_U       22+1024
#define ALT_V       47+1024
#define ALT_W       17+1024
#define ALT_X       45+1024
#define ALT_Y       21+1024
#define ALT_Z       44+1024

#define ALT_1       120+1024
#define ALT_2       121+1024
#define ALT_3       122+1024
#define ALT_4       123+1024
#define ALT_5       124+1024
#define ALT_6       125+1024
#define ALT_7       126+1024
#define ALT_8       127+1024
#define ALT_9       128+1024
#define ALT_0       129+1024

#define ALT_PLUS    131+1024
#define ALT_MINUS   130+1024
#define ALT_GREYPLUS    78+1024
#define ALT_GREYMINUS   74+1024
#define ALT_PIPE    43+1024
#define ALT_COMMA   51+1024
#define ALT_PERIOD  52+1024
#define ALT_QUESTION    53+1024
#define ALT_SEMI    39+1024
#define ALT_QUOTE   40+1024
#define ALT_LTBRKT  26+1024
#define ALT_RTBRKT  27+1024
#define ALT_TILDE   41+1024
#define ALT_ENTER   28+1024

#define CTRL_A      1
#define CTRL_B      2
#define CTRL_C      3
#define CTRL_D      4
#define CTRL_E      5
#define CTRL_F      6
#define CTRL_G      7
#define CTRL_H      8
#define CTRL_I      9
#define CTRL_J      10
#define CTRL_K      11
#define CTRL_L      12
#define CTRL_N      14
#define CTRL_O      15
#define CTRL_Q      17
#define CTRL_R      18
#define CTRL_S      19
#define CTRL_T      20
#define CTRL_U      21
#define CTRL_V      22
#define CTRL_W      23
#define CTRL_X      24
#define CTRL_Y      25
#define CTRL_Z      26

#define CTRL_MINUS  31
#define CTRL_GREYPLUS   144+1024
#define CTRL_GREYMINUS  142+1024
#define CTRL_2      3
#define CTRL_6      30
#define CTRL_RTBRKT 29
#define CTRL_PIPE   28

#define CTRL_HOME   119+1024
#define CTRL_BS     115+1024
#define CTRL_FWD    116+1024
#define CTRL_END    117+1024
#define CTRL_PGUP   132+1024
#define CTRL_PGDN   118+1024
#define CTRL_RIGHT  116+1024
#define CTRL_LEFT   115+1024
#define CTRL_UP     141+1024
#define CTRL_DN     145+1024
#define CTRL_ENTER  10

#define NUM_5       76+1024
#define CTRL_NUM_5  143+1024

#define HOME        71+1024
#define UP          72+1024
#define PGUP        73+1024
#define BS          75+1024
#define FWD         77+1024
#define END         79+1024
#define DN          80+1024
#define PGDN        81+1024
#define INS         82+1024
#define DEL         83+1024
#define LEFT        75+1024
#define RIGHT       77+1024

#define F1          59+1024
#define F2          60+1024
#define F3          61+1024
#define F4          62+1024
#define F5          63+1024
#define F6          64+1024
#define F7          65+1024
#define F8          66+1024
#define F9          67+1024
#define F10         68+1024
#define F11         133+1024
#define F12         134+1024

#define ALT_F1      104+1024
#define ALT_F2      105+1024
#define ALT_F3      106+1024
#define ALT_F4      107+1024
#define ALT_F5      108+1024
#define ALT_F6      109+1024
#define ALT_F7      110+1024
#define ALT_F8      111+1024
#define ALT_F9      112+1024
#define ALT_F10     113+1024
#define ALT_F11     139+1024
#define ALT_F12     140+1024

#define CTRL_F1     94+1024
#define CTRL_F2     95+1024
#define CTRL_F3     96+1024
#define CTRL_F4     97+1024
#define CTRL_F5     98+1024
#define CTRL_F6     99+1024
#define CTRL_F7     100+1024
#define CTRL_F8     101+1024
#define CTRL_F9     102+1024
#define CTRL_F10    103+1024
#define CTRL_F11    137+1024
#define CTRL_F12    138+1024
