PROJ = makecfg
PROJFILE = makecfg.mak
DEBUG = 0

CC  = cl
CFLAGS_G  = /Alfw /W4 /G2 /Zp1 /J /BATCH
CFLAGS_D  = /qc /Giout\$(PROJ).mdt /Zr /Zi /Od
CFLAGS_R  = /Od /Gs
MAPFILE_D  = NUL
MAPFILE_R  = NUL
LFLAGS_G  = /NOI /BATCH
LFLAGS_D  = /CO /INC /FAR /PACKC /PACKD /PMTYPE:VIO
LFLAGS_R  = /EXE /FAR /PACKC /PACKD /PMTYPE:VIO
LINKER  = link
ILINK  = ilink
LRF  = echo > NUL

DEF_FILE  = MAKECFG.DEF
OBJS  = out\MAKECFG.obj out\STRIPS.obj out\DELIMS.obj out\EVAL.obj\
        out\LITERAL.obj

all: out\$(PROJ).exe

.SUFFIXES:
.SUFFIXES: .obj .c

out\MAKECFG.obj : MAKECFG.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\MAKECFG.obj MAKECFG.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\MAKECFG.obj MAKECFG.C
!ENDIF

out\STRIPS.obj : STRIPS.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\STRIPS.obj STRIPS.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\STRIPS.obj STRIPS.C
!ENDIF

out\DELIMS.obj : DELIMS.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\DELIMS.obj DELIMS.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\DELIMS.obj DELIMS.C
!ENDIF

out\EVAL.obj : EVAL.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\EVAL.obj EVAL.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\EVAL.obj EVAL.C
!ENDIF

out\LITERAL.obj : LITERAL.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\LITERAL.obj LITERAL.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\LITERAL.obj LITERAL.C
!ENDIF


out\$(PROJ).exe : $(DEF_FILE) $(OBJS)
!IF $(DEBUG)
        $(LRF) @<<out\$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_D)
$(LLIBS_G: = +^
) +
$(LLIBS_D: = +^
) +
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_D);
<<
!ELSE
        $(LRF) @<<out\$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_R)
$(LLIBS_G: = +^
) +
$(LLIBS_R: = +^
) +
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_R);
<<
!ENDIF
!IF $(DEBUG)
        $(ILINK) -a -e "$(LINKER) @out\$(PROJ).lrf" $@
!ELSE
        $(LINKER) @out\$(PROJ).lrf
!ENDIF


.c.obj :
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Fo$@ $<
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Fo$@ $<
!ENDIF


run: out\$(PROJ).exe
        out\$(PROJ).exe $(RUNFLAGS)

debug: out\$(PROJ).exe
        CVP $(CVFLAGS) out\$(PROJ).exe $(RUNFLAGS)
