#define INCL_WIN
#define INCL_DOSERRORS

#include <process.h>
#include <io.h>
#include <stdarg.h>
#include <conio.h>
#include "mailer.h"
#include "bbs.h"
#include "keys.h"
#include "modem.h"
#include "nodelist.h"
#include "xmisc.h"
#include "xbbs.h"

/* globals created here */

    ULONG flFrameFlags = FCF_SYSMENU | FCF_SIZEBORDER | FCF_ICON |
                         FCF_SHELLPOSITION | FCF_TASKLIST |
                         FCF_TITLEBAR | FCF_MINMAX |
                         FCF_MENU | FCF_ACCELTABLE;
    MDM           *modems[MAXINSTANCES];
    unsigned long EndMeSEM[MAXINSTANCES];
    unsigned long InactiveSEM[MAXINSTANCES];
    unsigned long mailSEM[MAXINSTANCES];
    unsigned long callnowSEM[MAXINSTANCES];
    unsigned long killlogSEM[MAXINSTANCES];
    unsigned long initSEM[MAXINSTANCES];
    unsigned long scannowSEM[MAXINSTANCES];
    unsigned long pollnowSEM[MAXINSTANCES];
    USHORT        lastchld      = 0;
    USHORT        numcrank      = 1;
    USHORT        skipcrank     = 0;
    USHORT        focusline     = 1;
    USHORT        maxonscreen;
    USHORT        lastonscreen;
    USHORT        firstonscreen;
    unsigned long killmeyoubastardSEM = 0L;
    HWND          hwndFrame,hwndClient;
    HAB           hab;

    extern char          *progname;
    extern ADDR          *addresses;
    extern unsigned long ScanningSEM;
    extern int           *_threadid;
    extern BBS           *bbs;
    extern HWND          xdhwnd;
    extern char          *MBuff[MAXINSTANCES];
    extern char          *MBstart[MAXINSTANCES],*MBend[MAXINSTANCES];

    extern long _fastcall   read_nodelist (void);
    extern int  _fastcall   init_all (void);

    extern MRESULT EXPENTRY XBBSBoxProc (HWND,USHORT,MPARAM,MPARAM);
    extern MRESULT EXPENTRY StatusBoxProc (HWND,USHORT,MPARAM,MPARAM);
    extern MRESULT EXPENTRY LogBoxProc (HWND,USHORT,MPARAM,MPARAM);
    extern MRESULT EXPENTRY TransferBoxProc (HWND,USHORT,MPARAM,MPARAM);
    extern MRESULT EXPENTRY OutboundBoxProc (HWND,USHORT,MPARAM,MPARAM);
    extern MRESULT EXPENTRY bbsclientproc(HWND,USHORT,MPARAM,MPARAM);


void deinit (void) {

  register int x;

  for(x = 3;x < 256;x++)
    close(x);
}


int main (int argc,char *argv[]) {

  static USHORT        x,cp,atleastone = 0,tmp;
  static SEL           temp;
  static char          segname[80];
  static HMQ           hmq;
  static QMSG          qmsg;
  static SWP           swp;
  static ULONG         size;

  DosSetPrty(2,2,31,*_threadid);

  hab = WinInitialize(0);
  hmq = WinCreateMsgQueue(hab,16384);

  DosSemClear(&ScanningSEM);

  atexit(deinit);

  if(argc > 1) {
    numcrank = atoi(argv[1]);
    if(numcrank > MAXINSTANCES + 1)
      numcrank = MAXINSTANCES + 1;
    else if(numcrank < 1)
      numcrank = 1;
    if(argc > 2) {
      skipcrank = atoi(argv[2]);
       if(skipcrank >= numcrank)
        skipcrank = numcrank - 1;
    }
  }

  if(init_all())
    goto Die;
  set_bbs_defaults(0);

  DosSetPrty(2,2,0,*_threadid);

  for(x = 0;x < numcrank + 1;x++) {
    DosSemClear(&scannowSEM[cp]);
    DosSemClear(&pollnowSEM[cp]);
    DosSemClear(&initSEM[cp]);
    DosSemClear(&EndMeSEM[cp]);
    DosSemClear(&InactiveSEM[cp]);
    DosSemClear(&killlogSEM[cp]);
    DosSemClear(&callnowSEM[cp]);
    if(x && skipcrank && skipcrank >= x) {
      modems[x] = NULL;
      if(focusline == x)
        focusline++;
      lastchld++;
      continue;
    }
    cp = x;
    sprintf(segname,"\\SHAREMEM\\XBBS\\MDM.%u",cp);
    if(!DosAllocShrSeg(sizeof(MDM),segname,&temp))
      modems[cp] = (MDM *)MAKEP(temp,0);
    else {
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
                    "Can't allocate shared memory for control structure",
                    "XBBS",0,MB_CANCEL | MB_ICONHAND);
      lastchld++;
      continue;
    }
    MBuff[cp] = NULL;
    set_mailer_defaults(cp);
    DosSemClear(&modems[cp]->bbsrunningSEM);
    modems[cp]->lf = -1;
    modems[cp]->mh = -1;
    modems[cp]->cp = cp;
    modems[cp]->id = -1;
    modems[cp]->tt = -1;
    modems[cp]->threadid = -1;
    if(cp)
      modems[cp]->curbaud = modems[cp]->maxbaud;
    else
      modems[cp]->curbaud = 0;
    modems[cp]->afmsg = NULL;
    modems[cp]->hdr = NULL;

    tmp = open_prompt_files(cp,(int)cp,&modems[cp]->id,&modems[cp]->tt);
    if(tmp || modems[cp]->id == -1 || modems[cp]->tt == -1) {
      lastchld++;
      free(MBuff[cp]);
      MBuff[cp] = NULL;
      DosFreeSeg(temp);
      modems[cp] = NULL;
      continue;
    }

    if(!cp) {
      modems[cp]->threadid = _beginthread(crankup_bbs,NULL,49152U,(void *)&cp);   // local BBS
      modems[cp]->curbaud = 0;
      DosSleep(132L);
    }
    else {
      tmp = open_modem(cp);
      if(tmp) {
        DosBeep(440,250);   /* not a crucial error; we may be */
        free(MBuff[cp]);
        MBuff[cp] = NULL;
        modems[cp] = NULL;  /* skipping a commport in use by */
        DosFreeSeg(temp);   /* something else... */
        lastchld++;
        DosFreeSeg(temp);
        continue;
      }
      modems[cp]->threadid = _beginthread(mailer,NULL,49152U,(void *)&cp);
      DosSleep(132L);
    }

    if(modems[cp]->threadid == -1) {
      lastchld++;
      free(MBuff[cp]);
      MBuff[cp] = NULL;
      modems[cp] = NULL;
      DosFreeSeg(temp);
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
                    "Can't start mailer thread",
                    "XBBS",0,MB_CANCEL | MB_ICONHAND);
      continue;
    }

    if(cp) {
      atleastone++;
      lastchld++;
    }
  }

  if(!lastchld || !atleastone)
    WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
                    "Can't start anything.  The hell with it.",
                     "XBBS",0,MB_CANCEL | MB_ICONHAND);
  else {
    DosSetPrty(2,bbs->mainthread[0],bbs->mainthread[1],*_threadid);

    WinRegisterClass(hab,"WC_XBOX",XBBSBoxProc,0,4);
    WinRegisterClass(hab,"WC_XSTATUSBOX",StatusBoxProc,0,24);
    WinRegisterClass(hab,"WC_XLOGBOX",LogBoxProc,0,24);
    WinRegisterClass(hab,"WC_XTRANSFERBOX",TransferBoxProc,0,24);
    WinRegisterClass(hab,"WC_XOUTBOUNDBOX",OutboundBoxProc,0,24);
    WinRegisterClass(hab,"WC_XBBSBOX",bbsclientproc,0,8);

    size = (ULONG)sizeof(SWP);
    if(PrfQueryProfileData(HINI_USERPROFILE,"XBBS",
       "Sizepos",&swp,&size) == TRUE)
      flFrameFlags &= (~FCF_SHELLPOSITION);
    else
      size = 0L;
    hwndFrame = WinCreateStdWindow(HWND_DESKTOP,WS_VISIBLE,&flFrameFlags,
                                   "WC_XBOX","XBBS",0,0,
                                   IDI_ICON,&hwndClient);
    if(hwndFrame) {
      set_saved_position(hwndClient,"Sizepos");
      if(!LoadRexx())
        DosBeep(50,250);
      else
        RexxScriptFile(0,0,NULL);
      while(WinGetMsg(hab,&qmsg,NULL,0,0))
        WinDispatchMsg(hab,&qmsg);
      WinDestroyWindow(hwndFrame);
      UnloadRexx();
    }
    else
      WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
                    "Sonofabitch is broke.",
                    "XBBS",0,MB_CANCEL | MB_ICONHAND);
  }
Die:

  WinDestroyMsgQueue(hmq);
  WinTerminate(hab);
  DosBufReset(-1);
  return 0;
}
