PROJ = xsendpm
PROJFILE = xsendpm.mak
DEBUG = 0

CC  = cl
CFLAGS_G  = /AL /W4 /G2 /Zp1 /J /BATCH
CFLAGS_D  = /qc /Gs /Giout\$(PROJ).mdt /Zr /Zi /Od
CFLAGS_R  = /Os /Oi /Gm /Gs
MAPFILE_D  = NUL
MAPFILE_R  = NUL
LFLAGS_G  = /STACK:32687 /NOI /BATCH
LFLAGS_D  = /CO /INC /FAR /PACKC /PACKD /PMTYPE:PM
LFLAGS_R  = /EXE /FAR /PACKC /PACKD /PMTYPE:PM
LINKER  = link
ILINK  = ilink
LRF  = echo > NUL
RC  = rc

DEF_FILE  = XSENDPM.DEF
OBJS  = out\LOADADDR.obj out\srchpath.obj out\XSENDPM.obj out\STRIPS.obj\
        out\prseaddr.obj out\DELIMS.obj out\fgetsx.obj out\ffprintf.obj\
        out\nodelist.obj out\capname.obj
RESS  = out\XSENDPM.res

all: out\$(PROJ).exe

.SUFFIXES:
.SUFFIXES: .obj .res .c .rc

out\LOADADDR.obj : LOADADDR.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\LOADADDR.obj LOADADDR.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\LOADADDR.obj LOADADDR.C
!ENDIF

out\srchpath.obj : srchpath.c
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\srchpath.obj srchpath.c
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\srchpath.obj srchpath.c
!ENDIF

out\XSENDPM.obj : XSENDPM.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\XSENDPM.obj XSENDPM.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\XSENDPM.obj XSENDPM.C
!ENDIF

out\STRIPS.obj : STRIPS.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\STRIPS.obj STRIPS.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\STRIPS.obj STRIPS.C
!ENDIF

out\prseaddr.obj : prseaddr.c
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\prseaddr.obj prseaddr.c
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\prseaddr.obj prseaddr.c
!ENDIF

out\DELIMS.obj : DELIMS.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\DELIMS.obj DELIMS.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\DELIMS.obj DELIMS.C
!ENDIF

out\fgetsx.obj : fgetsx.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\fgetsx.obj fgetsx.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\fgetsx.obj fgetsx.C
!ENDIF

out\ffprintf.obj : ffprintf.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\ffprintf.obj ffprintf.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\ffprintf.obj ffprintf.C
!ENDIF

out\nodelist.obj : nodelist.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\nodelist.obj nodelist.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\nodelist.obj nodelist.C
!ENDIF

out\capname.obj : capname.C
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Foout\capname.obj capname.C
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Foout\capname.obj capname.C
!ENDIF

out\XSENDPM.res : XSENDPM.RC
        $(RC) /r XSENDPM.RC out\XSENDPM.res


out\$(PROJ).exe : $(DEF_FILE) $(OBJS) $(RESS)
!IF $(DEBUG)
        $(LRF) @<<out\$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_D)
$(LLIBS_G: = +^
) +
$(LLIBS_D: = +^
) +
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_D);
<<
!ELSE
        $(LRF) @<<out\$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_R)
$(LLIBS_G: = +^
) +
$(LLIBS_R: = +^
) +
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_R);
<<
!ENDIF
!IF $(DEBUG)
        $(ILINK) -a -e "$(LINKER) @out\$(PROJ).lrf" $@
!ELSE
        $(LINKER) @out\$(PROJ).lrf
!ENDIF
        $(RC) $(RESS) $@


.c.obj :
!IF $(DEBUG)
        $(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Fo$@ $<
!ELSE
        $(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Fo$@ $<
!ENDIF

.rc.res :
        $(RC) /r $< $@


run: out\$(PROJ).exe
        out\$(PROJ).exe $(RUNFLAGS)

debug: out\$(PROJ).exe
        CVP $(CVFLAGS) out\$(PROJ).exe $(RUNFLAGS)
